diff --git a/fs/exec.c b/fs/exec.c
index 4e497b9..343a377 100644
--- a/fs/exec.c
+++ b/fs/exec.c
@@ -871,6 +871,8 @@ int kernel_read(struct file *file, loff_t offset,
 	/* The cast to a user pointer is valid due to the set_fs() */
 	result = vfs_read(file, (void __user *)addr, count, &pos);
 	set_fs(old_fs);
+	/* we are not in an actual syscall but we have taken the same steps
+	 * so we need to undo them */
 	return result;
 }
 
diff --git a/fs/open.c b/fs/open.c
index d3ed817..b2653d3f 100644
--- a/fs/open.c
+++ b/fs/open.c
@@ -343,6 +343,8 @@ SYSCALL_DEFINE4(fallocate, int, fd, int, mode, loff_t, offset, loff_t, len)
 		error = vfs_fallocate(f.file, mode, offset, len);
 		fdput(f);
 	}
+
+	security_syscall_before_return();
 	return error;
 }
 
diff --git a/fs/read_write.c b/fs/read_write.c
index 190e0d36..0d67539 100644
--- a/fs/read_write.c
+++ b/fs/read_write.c
@@ -480,6 +480,7 @@ ssize_t vfs_read(struct file *file, char __user *buf, size_t count, loff_t *pos)
 		inc_syscr(current);
 	}
 
+	security_syscall_before_return();
 	return ret;
 }
 
@@ -566,6 +567,7 @@ ssize_t vfs_write(struct file *file, const char __user *buf, size_t count, loff_
 		file_end_write(file);
 	}
 
+	security_syscall_before_return();
 	return ret;
 }
 
@@ -884,6 +886,7 @@ static ssize_t do_readv_writev(int type, struct file *file,
 		else
 			fsnotify_modify(file);
 	}
+	security_syscall_before_return();
 	return ret;
 }
 
@@ -1008,13 +1011,15 @@ static ssize_t do_pwritev(unsigned long fd, const struct iovec __user *vec,
 SYSCALL_DEFINE3(readv, unsigned long, fd, const struct iovec __user *, vec,
 		unsigned long, vlen)
 {
-	return do_readv(fd, vec, vlen, 0);
+	int rc = do_readv(fd, vec, vlen, 0);
+	return rc;
 }
 
 SYSCALL_DEFINE3(writev, unsigned long, fd, const struct iovec __user *, vec,
 		unsigned long, vlen)
 {
-	return do_writev(fd, vec, vlen, 0);
+	int rc = do_writev(fd, vec, vlen, 0);
+	return rc;
 }
 
 SYSCALL_DEFINE5(preadv, unsigned long, fd, const struct iovec __user *, vec,
@@ -1022,7 +1027,8 @@ SYSCALL_DEFINE5(preadv, unsigned long, fd, const struct iovec __user *, vec,
 {
 	loff_t pos = pos_from_hilo(pos_h, pos_l);
 
-	return do_preadv(fd, vec, vlen, pos, 0);
+	int rc = do_preadv(fd, vec, vlen, pos, 0);
+	return rc;
 }
 
 SYSCALL_DEFINE6(preadv2, unsigned long, fd, const struct iovec __user *, vec,
@@ -1030,11 +1036,13 @@ SYSCALL_DEFINE6(preadv2, unsigned long, fd, const struct iovec __user *, vec,
 		int, flags)
 {
 	loff_t pos = pos_from_hilo(pos_h, pos_l);
+	int rc;
 
 	if (pos == -1)
-		return do_readv(fd, vec, vlen, flags);
-
-	return do_preadv(fd, vec, vlen, pos, flags);
+		rc = do_readv(fd, vec, vlen, flags);
+	else
+		rc = do_preadv(fd, vec, vlen, pos, flags);
+	return rc;
 }
 
 SYSCALL_DEFINE5(pwritev, unsigned long, fd, const struct iovec __user *, vec,
@@ -1042,7 +1050,8 @@ SYSCALL_DEFINE5(pwritev, unsigned long, fd, const struct iovec __user *, vec,
 {
 	loff_t pos = pos_from_hilo(pos_h, pos_l);
 
-	return do_pwritev(fd, vec, vlen, pos, 0);
+	int rc = do_pwritev(fd, vec, vlen, pos, 0);
+	return rc;
 }
 
 SYSCALL_DEFINE6(pwritev2, unsigned long, fd, const struct iovec __user *, vec,
@@ -1051,10 +1060,12 @@ SYSCALL_DEFINE6(pwritev2, unsigned long, fd, const struct iovec __user *, vec,
 {
 	loff_t pos = pos_from_hilo(pos_h, pos_l);
 
+	int rc;
 	if (pos == -1)
-		return do_writev(fd, vec, vlen, flags);
-
-	return do_pwritev(fd, vec, vlen, pos, flags);
+		rc = do_writev(fd, vec, vlen, flags);
+	else
+		rc = do_pwritev(fd, vec, vlen, pos, flags);
+	return rc;
 }
 
 #ifdef CONFIG_COMPAT
@@ -1109,6 +1120,7 @@ static ssize_t compat_do_readv_writev(int type, struct file *file,
 		else
 			fsnotify_modify(file);
 	}
+	security_syscall_before_return();
 	return ret;
 }
 
@@ -1423,6 +1435,7 @@ static ssize_t do_sendfile(int out_fd, int in_fd, loff_t *ppos,
 fput_in:
 	fdput(in);
 out:
+	security_syscall_before_return();
 	return retval;
 }
 
@@ -1442,7 +1455,8 @@ SYSCALL_DEFINE4(sendfile, int, out_fd, int, in_fd, off_t __user *, offset, size_
 		return ret;
 	}
 
-	return do_sendfile(out_fd, in_fd, NULL, count, 0);
+	ret = do_sendfile(out_fd, in_fd, NULL, count, 0);
+	return ret;
 }
 
 SYSCALL_DEFINE4(sendfile64, int, out_fd, int, in_fd, loff_t __user *, offset, size_t, count)
@@ -1561,6 +1575,7 @@ ssize_t vfs_copy_file_range(struct file *file_in, loff_t pos_in,
 
 	mnt_drop_write_file(file_out);
 
+	security_syscall_before_return();
 	return ret;
 }
 EXPORT_SYMBOL(vfs_copy_file_range);
@@ -1697,6 +1712,7 @@ int vfs_clone_file_range(struct file *file_in, loff_t pos_in,
 	}
 
 	mnt_drop_write_file(file_out);
+	security_syscall_before_return();
 	return ret;
 }
 EXPORT_SYMBOL(vfs_clone_file_range);
@@ -1800,6 +1816,7 @@ int vfs_dedupe_file_range(struct file *file, struct file_dedupe_range *same)
 	}
 
 out:
+	security_syscall_before_return();
 	return ret;
 }
 EXPORT_SYMBOL(vfs_dedupe_file_range);
diff --git a/fs/readdir.c b/fs/readdir.c
index 9d0212c..d62b392 100644
--- a/fs/readdir.c
+++ b/fs/readdir.c
@@ -138,6 +138,7 @@ SYSCALL_DEFINE3(old_readdir, unsigned int, fd,
 		error = buf.result;
 
 	fdput_pos(f);
+	security_syscall_before_return();
 	return error;
 }
 
@@ -238,6 +239,7 @@ SYSCALL_DEFINE3(getdents, unsigned int, fd,
 			error = count - buf.count;
 	}
 	fdput_pos(f);
+	security_syscall_before_return();
 	return error;
 }
 
@@ -322,5 +324,6 @@ SYSCALL_DEFINE3(getdents64, unsigned int, fd,
 			error = count - buf.count;
 	}
 	fdput_pos(f);
+	security_syscall_before_return();
 	return error;
 }
diff --git a/include/linux/lsm_hooks.h b/include/linux/lsm_hooks.h
index 558adfa..6e7153a 100644
--- a/include/linux/lsm_hooks.h
+++ b/include/linux/lsm_hooks.h
@@ -1652,6 +1652,11 @@ union security_list_options {
 				struct audit_context *actx);
 	void (*audit_rule_free)(void *lsmrule);
 #endif /* CONFIG_AUDIT */
+	void (*syscall_before_return)(void);
+	int (*mm_dup_security)(struct mm_struct *mm, struct mm_struct *oldmm);
+	void (*mm_sec_free)(struct mm_struct *mm);
+	int (*mq_store_msg)(struct msg_msg *msg);
+	void (*ptrace_unlink)(struct task_struct *p);
 };
 
 struct security_hook_heads {
@@ -1866,6 +1871,11 @@ struct security_hook_heads {
 	struct list_head audit_rule_match;
 	struct list_head audit_rule_free;
 #endif /* CONFIG_AUDIT */
+	struct list_head syscall_before_return;
+	struct list_head mm_dup_security;
+	struct list_head mm_sec_free;
+	struct list_head mq_store_msg;
+	struct list_head ptrace_unlink;
 };
 
 /*
diff --git a/include/linux/mm_types.h b/include/linux/mm_types.h
index 4a8aced..4d9f112 100644
--- a/include/linux/mm_types.h
+++ b/include/linux/mm_types.h
@@ -516,6 +516,7 @@ struct mm_struct {
 	atomic_long_t hugetlb_usage;
 #endif
 	struct work_struct async_put_work;
+	void *m_sec;
 };
 
 static inline void mm_init_cpumask(struct mm_struct *mm)
diff --git a/include/linux/rculist.h b/include/linux/rculist.h
index 8beb98d..f019cb0 100644
--- a/include/linux/rculist.h
+++ b/include/linux/rculist.h
@@ -404,7 +404,7 @@ static inline void list_splice_tail_init_rcu(struct list_head *list,
 	     &pos->member != (head);	\
 	     pos = list_entry_rcu(pos->member.next, typeof(*pos), member))
 
-/**
+/**rcu_read_lock
  * hlist_del_rcu - deletes entry from hash list without re-initialization
  * @n: the element to delete from the hash list.
  *
diff --git a/include/linux/security.h b/include/linux/security.h
index c2125e9..f784f5c 100644
--- a/include/linux/security.h
+++ b/include/linux/security.h
@@ -372,6 +372,11 @@ void security_inode_invalidate_secctx(struct inode *inode);
 int security_inode_notifysecctx(struct inode *inode, void *ctx, u32 ctxlen);
 int security_inode_setsecctx(struct dentry *dentry, void *ctx, u32 ctxlen);
 int security_inode_getsecctx(struct inode *inode, void **ctx, u32 *ctxlen);
+void security_syscall_before_return(void);
+int security_mm_dup_security(struct mm_struct *mm, struct mm_struct *oldmm);
+void security_mm_sec_free(struct mm_struct *mm);
+int security_mq_store_msg(struct msg_msg *msg);
+void security_ptrace_unlink(struct task_struct *p);
 #else /* CONFIG_SECURITY */
 struct security_mnt_opts {
 };
@@ -1153,6 +1158,23 @@ static inline int security_inode_getsecctx(struct inode *inode, void **ctx, u32
 {
 	return -EOPNOTSUPP;
 }
+static inline void security_syscall_before_return(void)
+{
+}
+static inline int security_mm_dup_security(struct mm_struct *mm, struct mm_struct *oldmm)
+{
+	return 0;
+}
+static inline void security_mm_sec_free(struct mm_struct *mm)
+{
+}
+static inline int security_mq_store_msg(struct msg_msg *msg)
+{
+	return 0;
+}
+static inline void security_ptrace_unlink(struct task_struct *p)
+{
+}
 #endif	/* CONFIG_SECURITY */
 
 #ifdef CONFIG_SECURITY_NETWORK
diff --git a/ipc/mqueue.c b/ipc/mqueue.c
index 8cbd6e6..6098809 100644
--- a/ipc/mqueue.c
+++ b/ipc/mqueue.c
@@ -1165,12 +1165,16 @@ SYSCALL_DEFINE5(mq_timedreceive, mqd_t, mqdes, char __user *, u_msg_ptr,
 		ret = 0;
 	}
 	if (ret == 0) {
-		ret = msg_ptr->m_ts;
+		ret = security_mq_store_msg(msg_ptr);
+		if (ret)
+			goto free_msg;
 
+		ret = msg_ptr->m_ts;
 		if ((u_msg_prio && put_user(msg_ptr->m_type, u_msg_prio)) ||
 			store_msg(u_msg_ptr, msg_ptr, msg_ptr->m_ts)) {
 			ret = -EFAULT;
 		}
+free_msg:
 		free_msg(msg_ptr);
 	}
 out_fput:
diff --git a/ipc/msg.c b/ipc/msg.c
index e12307d..913a5ab 100644
--- a/ipc/msg.c
+++ b/ipc/msg.c
@@ -995,7 +995,8 @@ long do_msgrcv(int msqid, void __user *buf, size_t bufsz, long msgtyp, int msgfl
 		return PTR_ERR(msg);
 	}
 
-	bufsz = msg_handler(buf, msg, bufsz);
+	if (!security_mq_store_msg(msg))
+		bufsz = msg_handler(buf, msg, bufsz);
 	free_msg(msg);
 
 	return bufsz;
diff --git a/kernel/fork.c b/kernel/fork.c
index 997ac1d..a8901fb 100644
--- a/kernel/fork.c
+++ b/kernel/fork.c
@@ -563,6 +563,7 @@ static __latent_entropy int dup_mmap(struct mm_struct *mm,
 		retval = -EINTR;
 		goto fail_uprobe_end;
 	}
+
 	flush_cache_dup_mm(oldmm);
 	uprobe_dup_mmap(oldmm, mm);
 	/*
@@ -852,6 +853,7 @@ EXPORT_SYMBOL_GPL(__mmdrop);
 static inline void __mmput(struct mm_struct *mm)
 {
 	VM_BUG_ON(atomic_read(&mm->mm_users));
+	security_mm_sec_free(mm);
 
 	uprobe_clear_state(mm);
 	exit_aio(mm);
@@ -1129,10 +1131,14 @@ static struct mm_struct *dup_mm(struct task_struct *tsk)
 	if (!mm_init(mm, tsk))
 		goto fail_nomem;
 
-	err = dup_mmap(mm, oldmm);
+	err = security_mm_dup_security(mm, oldmm);
 	if (err)
 		goto free_pt;
 
+	err = dup_mmap(mm, oldmm);
+	if (err)
+		goto free_sec;
+
 	mm->hiwater_rss = get_mm_rss(mm);
 	mm->hiwater_vm = mm->total_vm;
 
@@ -1141,6 +1147,8 @@ static struct mm_struct *dup_mm(struct task_struct *tsk)
 
 	return mm;
 
+free_sec:
+	security_mm_sec_free(mm);
 free_pt:
 	/* don't put binfmt in mmput, we haven't got module yet */
 	mm->binfmt = NULL;
diff --git a/kernel/ptrace.c b/kernel/ptrace.c
index e6474f7..e9ea99e 100644
--- a/kernel/ptrace.c
+++ b/kernel/ptrace.c
@@ -79,6 +79,7 @@ void __ptrace_unlink(struct task_struct *child)
 	list_del_init(&child->ptrace_entry);
 
 	spin_lock(&child->sighand->siglock);
+	security_ptrace_unlink(child);
 	child->ptrace = 0;
 	/*
 	 * Clear all pending traps and TRAPPING.  TRAPPING should be
@@ -110,6 +111,7 @@ void __ptrace_unlink(struct task_struct *child)
 	/*
 	 * If transition to TASK_STOPPED is pending or in TASK_TRACED, kick
 	 * @child in the butt.  Note that @resume should be used iff @child
+	 * b
 	 * is in TASK_TRACED; otherwise, we might unduly disrupt
 	 * TASK_KILLABLE sleeps.
 	 */
@@ -128,7 +130,7 @@ static bool ptrace_freeze_traced(struct task_struct *task)
 	if (task->jobctl & JOBCTL_LISTENING)
 		return ret;
 
-	spin_lock_irq(&task->sighand->siglock);
+		spin_lock_irq(&task->sighand->siglock);
 	if (task_is_traced(task) && !__fatal_signal_pending(task)) {
 		task->state = __TASK_TRACED;
 		ret = true;
@@ -481,6 +483,7 @@ static bool __ptrace_detach(struct task_struct *tracer, struct task_struct *p)
 	/* Mark it as in the process of being reaped. */
 	if (dead)
 		p->exit_state = EXIT_DEAD;
+
 	return dead;
 }
 
@@ -1073,7 +1076,7 @@ static struct task_struct *ptrace_get_task_struct(pid_t pid)
 	return child;
 }
 
-#ifndef arch_ptrace_attach
+#ifndef arch_trace_attach
 #define arch_ptrace_attach(child)	do { } while (0)
 #endif
 
diff --git a/kernel/signal.c b/kernel/signal.c
index 75761ac..a437f7a 100644
--- a/kernel/signal.c
+++ b/kernel/signal.c
@@ -2146,6 +2146,12 @@ int get_signal(struct ksignal *ksig)
 	 */
 	try_to_freeze();
 
+	/* At this point, we know that the process is going to either return to
+	 * userspace or restart its system call (if it was executing any), so
+	 * we let the LSMs know that they should erase all system call-related
+	 * state. */
+	security_syscall_before_return();
+
 relock:
 	spin_lock_irq(&sighand->siglock);
 	/*
diff --git a/mm/mmap.c b/mm/mmap.c
index 1af87c1..44bcc7f 100644
--- a/mm/mmap.c
+++ b/mm/mmap.c
@@ -2583,6 +2583,7 @@ int do_munmap(struct mm_struct *mm, unsigned long start, size_t len)
 {
 	unsigned long end;
 	struct vm_area_struct *vma, *prev, *last;
+	unsigned int partial_unmapping = 0;
 
 	if ((offset_in_page(start)) || start > TASK_SIZE || len > TASK_SIZE-start)
 		return -EINVAL;
@@ -2625,6 +2626,10 @@ int do_munmap(struct mm_struct *mm, unsigned long start, size_t len)
 		if (error)
 			return error;
 		prev = vma;
+
+		/* We have only done a partial unmapping since some pages from
+		 * the same vma will remain mapped */
+		partial_unmapping = 1;
 	}
 
 	/* Does it split the last one? */
diff --git a/net/socket.c b/net/socket.c
index 73dc69f..3766314 100644
--- a/net/socket.c
+++ b/net/socket.c
@@ -1657,6 +1657,7 @@ SYSCALL_DEFINE6(sendto, int, fd, void __user *, buff, size_t, len,
 
 out_put:
 	fput_light(sock->file, fput_needed);
+	security_syscall_before_return();
 out:
 	return err;
 }
@@ -1714,6 +1715,7 @@ SYSCALL_DEFINE6(recvfrom, int, fd, void __user *, ubuf, size_t, size,
 	}
 
 	fput_light(sock->file, fput_needed);
+	security_syscall_before_return();
 out:
 	return err;
 }
@@ -1938,30 +1940,8 @@ static int ___sys_sendmsg(struct socket *sock, struct user_msghdr __user *msg,
 
 	if (sock->file->f_flags & O_NONBLOCK)
 		msg_sys->msg_flags |= MSG_DONTWAIT;
-	/*
-	 * If this is sendmmsg() and current destination address is same as
-	 * previously succeeded address, omit asking LSM's decision.
-	 * used_address->name_len is initialized to UINT_MAX so that the first
-	 * destination address never matches.
-	 */
-	if (used_address && msg_sys->msg_name &&
-	    used_address->name_len == msg_sys->msg_namelen &&
-	    !memcmp(&used_address->name, msg_sys->msg_name,
-		    used_address->name_len)) {
-		err = sock_sendmsg_nosec(sock, msg_sys);
-		goto out_freectl;
-	}
+
 	err = sock_sendmsg(sock, msg_sys);
-	/*
-	 * If this is sendmmsg() and sending to current destination address was
-	 * successful, remember it.
-	 */
-	if (used_address && err >= 0) {
-		used_address->name_len = msg_sys->msg_namelen;
-		if (msg_sys->msg_name)
-			memcpy(&used_address->name, msg_sys->msg_name,
-			       used_address->name_len);
-	}
 
 out_freectl:
 	if (ctl_buf != ctl)
@@ -2059,6 +2039,7 @@ int __sys_sendmmsg(int fd, struct mmsghdr __user *mmsg, unsigned int vlen,
 	}
 
 	fput_light(sock->file, fput_needed);
+	security_syscall_before_return();
 
 	/* We only return an error if no datagrams were able to be sent */
 	if (datagrams != 0)
@@ -2158,6 +2139,7 @@ long __sys_recvmsg(int fd, struct user_msghdr __user *msg, unsigned flags)
 	err = ___sys_recvmsg(sock, msg, &msg_sys, flags, 0);
 
 	fput_light(sock->file, fput_needed);
+	security_syscall_before_return();
 out:
 	return err;
 }
@@ -2204,13 +2186,10 @@ int __sys_recvmmsg(int fd, struct mmsghdr __user *mmsg, unsigned int vlen,
 	compat_entry = (struct compat_mmsghdr __user *)mmsg;
 
 	while (datagrams < vlen) {
-		/*
-		 * No need to ask LSM for more than the first datagram.
-		 */
 		if (MSG_CMSG_COMPAT & flags) {
 			err = ___sys_recvmsg(sock, (struct user_msghdr __user *)compat_entry,
 					     &msg_sys, flags & ~MSG_WAITFORONE,
-					     datagrams);
+					     0);
 			if (err < 0)
 				break;
 			err = __put_user(err, &compat_entry->msg_len);
@@ -2219,7 +2198,7 @@ int __sys_recvmmsg(int fd, struct mmsghdr __user *mmsg, unsigned int vlen,
 			err = ___sys_recvmsg(sock,
 					     (struct user_msghdr __user *)entry,
 					     &msg_sys, flags & ~MSG_WAITFORONE,
-					     datagrams);
+					     0);
 			if (err < 0)
 				break;
 			err = put_user(err, &entry->msg_len);
diff --git a/security/Kconfig b/security/Kconfig
index 118f454..0d95f57 100644
--- a/security/Kconfig
+++ b/security/Kconfig
@@ -164,6 +164,7 @@ source security/tomoyo/Kconfig
 source security/apparmor/Kconfig
 source security/loadpin/Kconfig
 source security/yama/Kconfig
+source security/blare/Kconfig
 
 source security/integrity/Kconfig
 
@@ -173,6 +174,7 @@ choice
 	default DEFAULT_SECURITY_SMACK if SECURITY_SMACK
 	default DEFAULT_SECURITY_TOMOYO if SECURITY_TOMOYO
 	default DEFAULT_SECURITY_APPARMOR if SECURITY_APPARMOR
+	default DEFAULT_SECURITY_BLARE if SECURITY_BLARE
 	default DEFAULT_SECURITY_DAC
 
 	help
@@ -191,6 +193,9 @@ choice
 	config DEFAULT_SECURITY_APPARMOR
 		bool "AppArmor" if SECURITY_APPARMOR=y
 
+	config DEFAULT_SECURITY_BLARE
+		bool "Blare" if SECURITY_BLARE=y
+
 	config DEFAULT_SECURITY_DAC
 		bool "Unix Discretionary Access Controls"
 
@@ -202,6 +207,7 @@ config DEFAULT_SECURITY
 	default "smack" if DEFAULT_SECURITY_SMACK
 	default "tomoyo" if DEFAULT_SECURITY_TOMOYO
 	default "apparmor" if DEFAULT_SECURITY_APPARMOR
+	default "blare" if DEFAULT_SECURITY_BLARE
 	default "" if DEFAULT_SECURITY_DAC
 
 endmenu
diff --git a/security/Makefile b/security/Makefile
index f2d71cd..cd63291 100644
--- a/security/Makefile
+++ b/security/Makefile
@@ -9,6 +9,7 @@ subdir-$(CONFIG_SECURITY_TOMOYO)        += tomoyo
 subdir-$(CONFIG_SECURITY_APPARMOR)	+= apparmor
 subdir-$(CONFIG_SECURITY_YAMA)		+= yama
 subdir-$(CONFIG_SECURITY_LOADPIN)	+= loadpin
+subdir-$(CONFIG_SECURITY_BLARE)		+= blare
 
 # always enable default capabilities
 obj-y					+= commoncap.o
@@ -24,6 +25,7 @@ obj-$(CONFIG_SECURITY_TOMOYO)		+= tomoyo/
 obj-$(CONFIG_SECURITY_APPARMOR)		+= apparmor/
 obj-$(CONFIG_SECURITY_YAMA)		+= yama/
 obj-$(CONFIG_SECURITY_LOADPIN)		+= loadpin/
+obj-$(CONFIG_SECURITY_BLARE)		+= blare/
 obj-$(CONFIG_CGROUP_DEVICE)		+= device_cgroup.o
 
 # Object integrity file lists
diff --git a/security/blare/Kconfig b/security/blare/Kconfig
new file mode 100644
index 0000000..dfdb893
--- /dev/null
+++ b/security/blare/Kconfig
@@ -0,0 +1,23 @@
+config SECURITY_BLARE
+	bool "Blare support"
+	depends on SECURITY
+	default n
+	help
+	  This selects Blare, an information flow control security mechanism,
+	  which permits the enforcement of data flow policies between
+	  operating system-scale containers of informations such as processes,
+	  files, sockets, etc.
+
+	  If you are unsure how to answer this question, answer N.
+
+config SECURITY_BLARE_TAGS_SIZE
+	int "Size of Blare information tags (in number of 32-bits int)"
+	range 4 1024
+	default 16
+	depends on SECURITY_BLARE
+	help
+	  Selects the size of the bitfield arrays that store Blare information
+	  tags. A larger number means more tags are available, and possibly
+	  more expressive security policies can be defined but also a larger
+	  memory footprint. Remember that an information tag is allocated for
+	  every inode and task in the system.
diff --git a/security/blare/Makefile b/security/blare/Makefile
new file mode 100644
index 0000000..bf983a1
--- /dev/null
+++ b/security/blare/Makefile
@@ -0,0 +1 @@
+obj-$(CONFIG_SECURITY_BLARE) := blare_lsm.o open_flows.o securityfs.o
diff --git a/security/blare/blare.h b/security/blare/blare.h
new file mode 100644
index 0000000..90350af
--- /dev/null
+++ b/security/blare/blare.h
@@ -0,0 +1,105 @@
+/*
+ * Blare Linux Security Module
+ *
+ * Authors: Christophe Hauser <christophe@cs.ucsb.edu>
+ *          Guillaume Brogi <guillaume.brogi@akheros.com>
+ *          Laurent Georget <laurent.georget@supelec.fr>
+ *
+ * Copyright (C) 2010-2016 CentraleSupelec
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2, as
+ * published by the Free Software Foundation.
+ *
+ */
+#ifndef _BLARE_H
+#define _BLARE_H
+
+#include <linux/xattr.h>
+#include <linux/types.h>
+#include <linux/mutex.h>
+#include <linux/fs.h>
+#include <linux/bitops.h>
+
+struct msg_msg;
+
+#define BLARE_XATTR_TAG_SUFFIX "blare.tag"
+#define BLARE_XATTR_TAG XATTR_SECURITY_PREFIX BLARE_XATTR_TAG_SUFFIX
+#define BLARE_XATTR_TAG_LEN (sizeof(BLARE_XATTR_TAG) - 1)
+
+#define BLARE_TAGS_NUMBER CONFIG_SECURITY_BLARE_TAGS_SIZE
+
+#define BLARE_FILE_TYPE 0
+#define BLARE_MM_TYPE 1
+#define BLARE_MSG_TYPE 2
+
+/* defined in securityfs */
+extern int blare_enabled;
+
+struct info_tags {
+	__u32 tags[BLARE_TAGS_NUMBER];
+};
+
+struct blare_inode_sec {
+	struct info_tags info;
+};
+
+struct blare_mm_sec {
+	struct info_tags info;
+	atomic_t users;
+};
+
+struct blare_msg_sec {
+	struct info_tags info;
+};
+
+/* open_flows.c */
+int register_flow_file_to_mm(struct file *file, struct mm_struct *mm);
+int register_flow_mm_to_file(struct mm_struct *mm, struct file *file);
+int register_flow_msg_to_mm(struct msg_msg *msg, struct mm_struct *mm);
+int register_new_tags_for_mm(const struct info_tags *tags, struct mm_struct *mm);
+int register_read(struct file *file);
+int register_write(struct file *file);
+int register_msg_reception(struct msg_msg *msg);
+int register_ptrace_attach(struct task_struct *tracer,
+			   struct task_struct *child);
+void unregister_current_flow(void);
+void unregister_dying_task_flow(struct task_struct *p);
+void unregister_ptrace(struct task_struct *child);
+struct blare_mm_sec *dup_msec(struct blare_mm_sec *old_msec);
+void msec_get(struct blare_mm_sec *msec);
+void msec_put(struct blare_mm_sec *msec);
+
+static inline int tags_count(const struct info_tags *tags) {
+	int count = 0;
+	int i;
+	for (i=0 ; i<BLARE_TAGS_NUMBER ; i++)
+		count += hweight32(tags->tags[i]);
+	return count;
+}
+
+static inline void initialize_tags(struct info_tags *tags) {
+	int i;
+	for (i=0 ; i<BLARE_TAGS_NUMBER ; i++)
+		tags->tags[i] = 0;
+}
+
+static inline void copy_tags(struct info_tags *dest, const struct info_tags *src) {
+	int i;
+	for (i=0 ; i<BLARE_TAGS_NUMBER ; i++)
+		dest->tags[i] = src->tags[i];
+}
+
+/* securityfs.c */
+int blare_init_fs(void);
+bool blare_is_traced(const struct info_tags* tags_added);
+int blare_trace_all(const struct info_tags* tags_added, void* src, int src_type,
+		void* dest, int dest_type);
+int blare_tags_to_string(const __u32 *tag, char** buffer);
+int blare_tags_from_string(const char* buf, size_t length, __u32 *tag);
+
+/* Tag 0 stops the propagation, and doesn't propagate */
+static inline bool blare_stop_propagate(const struct info_tags* tags) {
+  return (tags->tags[0] & 1);
+}
+#endif // _BLARE_H
diff --git a/security/blare/blare_lsm.c b/security/blare/blare_lsm.c
new file mode 100644
index 0000000..3c7d343
--- /dev/null
+++ b/security/blare/blare_lsm.c
@@ -0,0 +1,643 @@
+/*
+ * Blare Linux Security Module
+ *
+ * Authors: Christophe Hauser <christophe@cs.ucsb.edu>
+ *          Guillaume Brogi <guillaume.brogi@akheros.com>
+ *          Laurent Georget <laurent.georget@supelec.fr>
+ *
+ * Copyright (C) 2010-2016 CentraleSupelec
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2, as
+ * published by the Free Software Foundation.
+ *
+ */
+
+#include <linux/lsm_hooks.h>
+#include <linux/file.h>
+#include <linux/fs.h>
+#include <linux/slab.h>
+#include <linux/gfp.h>
+#include <linux/binfmts.h>
+#include <net/sock.h>
+#include <net/af_unix.h>
+#include <linux/xattr.h>
+#include <linux/types.h>
+#include <linux/msg.h>
+#include <linux/mman.h>
+
+#include "blare.h"
+
+static int blare_bprm_set_creds(struct linux_binprm *bprm)
+{
+	struct blare_mm_sec *msec;
+	struct inode *inode = file_inode(bprm->file);
+	struct blare_inode_sec *isec;
+
+	bprm->cred->security = NULL;
+
+	/* For now, we are only concerned with the permissions of the initial
+	 * file, not the wrappers/interpreters/etc. */
+	if (bprm->cred_prepared)
+		return 0;
+
+	isec = inode->i_security;
+	if (!isec) {
+		pr_warn("No security attributes in inode");
+		return 0;
+	}
+
+	if (capable(CAP_MAC_ADMIN))
+		return 0;
+
+	msec = kmalloc(sizeof(struct blare_mm_sec), GFP_KERNEL);
+	if (!msec)
+		return -ENOMEM;
+
+	copy_tags(&msec->info, &isec->info);
+	atomic_set(&msec->users, 1);
+	bprm->cred->security = msec;
+
+	return 0;
+}
+
+static void blare_bprm_committing_creds(struct linux_binprm *bprm)
+{
+	/* the new process is not started yet so we cannot race with anybody,
+	 * right? */
+	current->mm->m_sec = bprm->cred->security;
+	bprm->cred->security = NULL;
+}
+
+static int blare_inode_alloc_security(struct inode* inode)
+{
+	struct blare_inode_sec *isec;
+
+	inode->i_security = kmalloc(sizeof(struct blare_inode_sec), GFP_NOFS);
+	if (!inode->i_security)
+		return -ENOMEM;
+
+	isec = inode->i_security;
+	initialize_tags(&isec->info);
+
+	return 0;
+}
+
+static void blare_inode_free_security(struct inode* inode)
+{
+	struct blare_inode_sec *isec = inode->i_security;
+	kfree(isec);
+	inode->i_security = NULL;
+}
+
+static int blare_inode_setxattr(struct dentry *dentry, const char *name,
+				const void *value, size_t size, int flags)
+{
+	struct inode *inode = d_backing_inode(dentry);
+
+	/* You cannot change the security extended attributes unless you are
+	 * the Security Administrator (capability MAC_ADMIN) or the owner of
+	 * the file (for debugging or decentralization purposes) */
+	if (strcmp(name, BLARE_XATTR_TAG) == 0) {
+		if (!uid_eq(current_fsuid(), inode->i_uid) &&
+		    !capable(CAP_MAC_ADMIN))
+			return -EPERM;
+		else {
+		  if (size % sizeof(__u32))
+		    return -EINVAL;
+		  if (size > BLARE_TAGS_NUMBER * sizeof(__u32)) {
+		    pr_err("Blare: The tags are too large for this system.\n"
+			   "Consider compiling your kernel with "
+			   "CONFIG_SECURITY_BLARE_TAGS_SIZE = %lu or more.",
+			   size/sizeof(__u32));
+		    return -EINVAL;
+		}
+		
+			return 0;
+		}
+	}
+
+	/* general case */
+	return cap_inode_setxattr(dentry, name, value, size, flags);
+}
+
+static int blare_inode_removexattr(struct dentry *dentry, const char *name)
+{
+	/* There's no post_removexattr hook so we must handle the removal of
+	 * attributes here, this is very similar to setxattr but we must
+	 * refresh the inode security attributes here */
+	struct inode *inode = d_backing_inode(dentry);
+	if (strcmp(name, BLARE_XATTR_TAG) == 0) {
+		if (!uid_eq(current_fsuid(), inode->i_uid) &&
+		    !capable(CAP_MAC_ADMIN)) {
+			return -EPERM;
+		} else {
+			if (inode->i_security) {
+				struct blare_inode_sec *isec = inode->i_security;
+				initialize_tags(&isec->info);
+			}
+			return 0;
+		}
+	}
+
+	/* general case */
+	return cap_inode_removexattr(dentry, name);
+}
+
+static int blare_inode_getsecurity(struct inode *inode, const char *name, void **buffer, bool alloc)
+{
+	struct blare_inode_sec *isec;
+	int size = 0;
+
+	if (strcmp(name, BLARE_XATTR_TAG_SUFFIX) != 0)
+		return -EINVAL;
+
+	if (!inode || !inode->i_security) {
+		pr_warn("No security attached to the inode!");
+		return -ENODATA;
+	}
+
+	isec = inode->i_security;
+	size = sizeof(__u32) * BLARE_TAGS_NUMBER;
+	if (!alloc || !buffer)
+		goto ret;
+
+	*buffer = kmemdup(isec->info.tags, size, GFP_NOFS);
+	if (!*buffer)
+		return -ENOMEM;
+
+ret:
+	return size;
+}
+
+static void blare_release_secctx(char *secdata, u32 seclen)
+{
+	kfree(secdata);
+}
+
+static int blare_inode_setsecurity(struct inode *inode, const char *name,
+				   const void *value, size_t size, int flags)
+{
+	struct blare_inode_sec *isec;
+	const __u32 *tags_value;
+	int i;
+
+	if (strcmp(name, BLARE_XATTR_TAG_SUFFIX) != 0)
+		return -EOPNOTSUPP;
+
+	if (!value || !size)
+		return -EACCES;
+
+	if (!inode || !inode->i_security) {
+		pr_warn("No security attached to the inode!");
+		return -ENODATA;
+	}
+
+	isec = inode->i_security;
+	tags_value = value;
+
+	for (i=0 ; i<BLARE_TAGS_NUMBER ; i++)
+		isec->info.tags[i] = tags_value[i];
+
+	return 0;
+}
+
+static int blare_file_permission(struct file *file, int mask)
+{
+	struct inode *inode = file_inode(file);
+	struct blare_inode_sec *isec = inode->i_security;
+	struct blare_mm_sec *msec;
+	int ret = 0;
+	char pathbuffer[256];
+	char * path;
+
+	if (!mask) /* an existence check is not a flow */
+		return 0;
+
+	if (!current->mm)
+		return 0; /* kernel threads do not propagate flows */
+
+	msec = current->mm->m_sec;
+	if (!msec || !isec) /* the FS is not fully initialized or the task */
+		return 0;   /* is privileged */
+
+	if (mask & MAY_READ) {
+		path = d_path(&file->f_path, pathbuffer, 256);
+		pr_debug("kblare reading %s\n", path);
+		ret = register_read(file);
+	}
+
+	if (!ret && (mask & MAY_APPEND || mask & MAY_WRITE)) {
+		/*struct dentry *dentry = file_dentry(file);
+		dget(dentry);*/
+		path = d_path(&file->f_path, pathbuffer, 256);
+		pr_debug("kblare writing %s\n", path);
+		ret = register_write(file);
+	}
+
+	return ret;
+}
+
+static int blare_socket_sendmsg(struct socket *socket, struct msghdr *msg, int size)
+{
+	struct file *file = socket->file;
+	struct inode *inode = SOCK_INODE(socket);
+	struct blare_inode_sec *isec = inode->i_security;
+	struct blare_mm_sec *msec;
+
+	if (!current->mm)
+		return 0;
+
+	msec = current->mm->m_sec;
+	if (!msec || !isec)
+		return 0;
+
+	/* Conceptually, the communication channel bears the security label,
+	 * in practice, the sending end stores the security attributes */
+	return register_write(file);
+}
+
+static int blare_socket_recvmsg(struct socket *socket, struct msghdr *msg, int size, int flags)
+{
+	struct file *file;
+	struct inode *inode;
+	struct blare_inode_sec *isec;
+	struct blare_mm_sec *msec;
+	struct sock *sk = socket->sk;
+	struct sock *peer;
+	int rc = 0;
+
+	if (!current->mm)
+		return 0;
+
+	msec = current->mm->m_sec;
+	if (!msec)
+		return 0;
+
+	if (sk->sk_family == PF_UNIX) {
+		peer = unix_peer_get(sk);
+		if (!peer)
+			return 0;
+
+		unix_state_lock(peer);
+		if (!peer->sk_socket) {
+			unix_state_unlock(peer);
+			goto put_sock;
+		}
+		inode = SOCK_INODE(peer->sk_socket);
+		file = peer->sk_socket->file;
+		unix_state_unlock(peer);
+		isec = inode->i_security;
+		if (!isec)
+			goto put_sock;
+
+		rc = register_read(file);
+put_sock:
+		sock_put(peer);
+	} /* else ? */
+	return rc;
+}
+
+static void blare_d_instantiate(struct dentry *opt_dentry, struct inode *inode)
+{
+	struct blare_inode_sec *isec;
+	struct dentry *dentry;
+	int rc;
+	if (!inode || !inode->i_security)
+		return;
+
+	/* If this method is called with opt_dentry == root of the filesystem
+	 * this may mean that the superblock is being initialized, in which case
+	 * it is a bad idea to try to play with its xattrs.
+	 * We just don't give tags to the dentry in this case
+	 * TODO: defer the initialization and give the tags after the superblock
+	 * is ready
+	 */
+	if (opt_dentry->d_parent == opt_dentry)
+		return;
+
+	isec = inode->i_security;
+	if (!(inode->i_opflags & IOP_XATTR))
+		return;
+
+	dentry = dget(opt_dentry);
+	if (!dentry) {
+		pr_info("Void dentry: %s : %p (%p)\n", __func__, dentry, opt_dentry);
+		return;
+	}
+
+	rc = __vfs_getxattr(dentry, inode, BLARE_XATTR_TAG, NULL, 0);
+	if (rc <= 0) /* no xattrs available or no tags */
+		goto dput;
+
+	if (rc % sizeof(__u32)) {
+	  pr_err("Blare: tags of file %pd2 have been corrupted on disk",
+		 dentry);
+	  goto dput;
+	}
+	
+	if (rc <= BLARE_TAGS_NUMBER * sizeof(__u32)) {
+		int i,j;
+		rc = __vfs_getxattr(dentry, inode, BLARE_XATTR_TAG,
+				    isec->info.tags, rc);
+
+		/* we have to adjust the tag size if rc < BLARE_TAGS_NUMBER
+		 * (happens if the tag size is bigger now than when the file
+		 * last got a new tag)
+		 * we could also refresh the xattrs on disk while we are at it
+		 * but is it really necessary? */
+		for (i=rc/sizeof(__u32), j=rc ; j<BLARE_TAGS_NUMBER ;
+		     i++, j+=sizeof(__u32))
+			isec->info.tags[i] = 0;
+	} else {
+		pr_err("Blare: file %pd2 comes from a system where tags are "
+		       "longer.\nConsider compiling your kernel with "
+		       "CONFIG_SECURITY_BLARE_TAGS_SIZE = %lu or more.",
+		       dentry, rc/sizeof(__u32));
+		rc = __vfs_getxattr(dentry, inode, BLARE_XATTR_TAG,
+				    isec->info.tags,
+				    BLARE_TAGS_NUMBER * sizeof(__u32));
+	}
+
+dput:
+	dput(dentry);
+
+}
+
+static void blare_inode_post_setxattr(struct dentry *dentry, const char *name,
+				      const void *value, size_t size,
+				      int flags)
+{
+	struct inode *inode = d_backing_inode(dentry);
+	struct blare_inode_sec *isec;
+	int i,j;
+	
+	if (strcmp(name, BLARE_XATTR_TAG) != 0)
+		return;
+
+	isec = inode->i_security;
+	if (!isec) {
+		pr_err("Blare: missing inode security structure");
+		return;
+	}
+
+	WARN_ON(size != sizeof(__u32) * BLARE_TAGS_NUMBER);
+	memcpy(isec->info.tags, value, size);
+}
+
+static int blare_mm_dup_security(struct mm_struct *mm, struct mm_struct *oldmm)
+{
+	struct blare_mm_sec *old_msec = oldmm->m_sec;
+	struct blare_mm_sec *msec;
+
+	mm->m_sec = NULL;
+	if (!old_msec)
+		return 0;
+
+	msec = dup_msec(old_msec);
+	if (IS_ERR(msec))
+		return PTR_ERR(msec);
+
+	mm->m_sec = msec;
+	return 0;
+}
+
+static void blare_mm_sec_free(struct mm_struct *mm)
+{
+	struct blare_mm_sec *msec = mm->m_sec;
+
+	if (msec) {
+		msec_put(msec);
+		mm->m_sec = NULL;
+	}
+}
+
+static int blare_mq_store_msg(struct msg_msg *msg)
+{
+	int ret;
+	struct blare_mm_sec *msec = current->mm->m_sec;
+	if (!msec || !msg->security)
+		return 0;
+
+	ret = register_msg_reception(msg);
+	return ret;
+}
+
+static int blare_msg_msg_alloc_security(struct msg_msg *msg)
+{
+	struct blare_mm_sec *msec = current->mm->m_sec;
+	struct blare_msg_sec *msgsec;
+	if (!msec)
+		return 0;
+
+	msgsec = kmalloc(sizeof(struct blare_msg_sec), GFP_KERNEL);
+	if (!msgsec)
+		goto nomem;
+	copy_tags(&msgsec->info, &msec->info);
+
+	msg->security = msgsec;
+	return 0;
+
+nomem:
+	return -ENOMEM;
+}
+
+static void blare_msg_msg_free_security(struct msg_msg *msg)
+{
+	struct blare_msg_sec *msgsec = msg->security;
+	kfree(msgsec);
+}
+
+static int blare_ptrace_access_check(struct task_struct *child,
+				     unsigned int unused)
+{
+	struct blare_mm_sec *tracer_msec = current->mm->m_sec;
+	struct blare_mm_sec *child_msec = child->mm->m_sec;
+
+	if (!tracer_msec || !child_msec)
+		return 0;
+
+	return register_ptrace_attach(current, child);
+}
+
+static int blare_ptrace_traceme(struct task_struct *parent)
+{
+	struct blare_mm_sec *tracer_msec = parent->mm->m_sec;
+	struct blare_mm_sec *child_msec = current->mm->m_sec;
+
+	if (!tracer_msec || !child_msec)
+		return 0;
+
+	return register_ptrace_attach(parent, current);
+}
+
+static void blare_ptrace_unlink(struct task_struct *child)
+{
+	if (!child->mm || !child->mm->m_sec)
+		return;
+
+	/* don't bother detaching the mm->m_sec if the child won't use it */
+	if (child->flags & PF_EXITING)
+		return;
+
+	unregister_ptrace(child);
+}
+
+/*
+ * blare_task_free makes sure that the discrete_flows list does not get too
+ * cluttered over time by making sure the entry corresponding to a given task
+ * are removed when said task exits. A valid way to have a post-death entry
+ * in the discrete_flows list is when a process is killed by a signal in the
+ * middle of a system call for instance.
+ */
+static void blare_task_free(struct task_struct *task)
+{
+	unregister_dying_task_flow(task);
+}
+
+static int blare_mmap_file(struct file *file, unsigned long reqprot,
+			   unsigned long prot, unsigned long flags)
+{
+	int ret;
+	struct blare_mm_sec *msec;
+	struct blare_inode_sec *isec;
+
+	if (!current->mm || !file)
+		return 0;
+
+	msec = current->mm->m_sec;
+	isec = file_inode(file)->i_security;
+
+	if (!msec || !isec)
+		return 0;
+
+	ret = register_flow_file_to_mm(file, current->mm);
+	if (!ret && (prot & PROT_WRITE) && (flags & MAP_SHARED))
+		ret = register_flow_mm_to_file(current->mm, file);
+
+	return ret;
+}
+
+static int blare_file_mprotect(struct vm_area_struct *vma,
+			       unsigned long reqprot, unsigned long prot)
+{
+	int ret = 0;
+	struct file *file = vma->vm_file;
+	struct blare_mm_sec *msec;
+	struct blare_inode_sec *isec;
+
+	if (!current->mm || !file)
+		return 0;
+
+	msec = current->mm->m_sec;
+	isec = file_inode(file)->i_security;
+
+	if (!msec || !isec)
+		return 0;
+
+	if ((prot & PROT_WRITE) && (vma->vm_flags & VM_SHARED))
+		ret = register_flow_mm_to_file(current->mm, file);
+
+	return ret;
+}
+
+static int blare_getprocattr(struct task_struct *p, char *name, char **value)
+{
+	struct blare_mm_sec *msec;
+
+	if (!p->mm)
+		return -EINVAL;
+
+	msec = p->mm->m_sec;
+	if (!msec)
+		return -ENODATA;
+
+	if (strcmp(name, "current") != 0)
+		return -EINVAL;
+
+	return blare_tags_to_string(msec->info.tags, value);
+}
+
+static int blare_setprocattr(struct task_struct *p, char *name,
+			     void *value, size_t size)
+{
+	struct info_tags new_tags;
+	struct blare_mm_sec *msec;
+	const struct cred *tcred;
+	int ret, nbytes;
+
+	if (strcmp(name, "current") != 0)
+		return -EINVAL;
+
+	/* a task may change the tags of another if it is CAP_MAC_ADMIN */
+	rcu_read_lock();
+	tcred = __task_cred(p);
+	if (p != current &&
+	    !has_ns_capability(current, tcred->user_ns, CAP_MAC_ADMIN)) {
+		rcu_read_unlock();
+		return -EPERM;
+	}
+	rcu_read_unlock();
+
+	if (!p->mm)
+		return -EINVAL;
+
+	msec = p->mm->m_sec;
+	if (!msec)
+		return -ENODATA;
+
+	if ((nbytes = blare_tags_from_string((char*) value, size, new_tags.tags)) < size)
+		return -EINVAL;
+
+	/* it is impossible to remove tags, you can only add some */
+	ret = register_new_tags_for_mm(&new_tags, p->mm);
+	if (ret)
+		return ret;
+
+	return nbytes;
+}
+
+static struct security_hook_list blare_hooks[] = {
+	LSM_HOOK_INIT(inode_alloc_security,blare_inode_alloc_security),
+	LSM_HOOK_INIT(inode_free_security,blare_inode_free_security),
+	LSM_HOOK_INIT(inode_getsecurity,blare_inode_getsecurity),
+	LSM_HOOK_INIT(inode_setsecurity,blare_inode_setsecurity),
+	LSM_HOOK_INIT(d_instantiate,blare_d_instantiate),
+	LSM_HOOK_INIT(inode_post_setxattr,blare_inode_post_setxattr),
+	LSM_HOOK_INIT(inode_setxattr,blare_inode_setxattr),
+	LSM_HOOK_INIT(inode_removexattr,blare_inode_removexattr),
+	LSM_HOOK_INIT(release_secctx,blare_release_secctx),
+	LSM_HOOK_INIT(bprm_set_creds,blare_bprm_set_creds),
+	LSM_HOOK_INIT(bprm_committing_creds,blare_bprm_committing_creds),
+	LSM_HOOK_INIT(file_permission,blare_file_permission),
+	LSM_HOOK_INIT(socket_sendmsg,blare_socket_sendmsg),
+	LSM_HOOK_INIT(socket_recvmsg,blare_socket_recvmsg),
+	LSM_HOOK_INIT(syscall_before_return,unregister_current_flow),
+	LSM_HOOK_INIT(mm_dup_security,blare_mm_dup_security),
+	LSM_HOOK_INIT(mm_sec_free,blare_mm_sec_free),
+	LSM_HOOK_INIT(mq_store_msg,blare_mq_store_msg),
+	LSM_HOOK_INIT(msg_msg_alloc_security,blare_msg_msg_alloc_security),
+	LSM_HOOK_INIT(msg_msg_free_security,blare_msg_msg_free_security),
+	LSM_HOOK_INIT(ptrace_access_check,blare_ptrace_access_check),
+	LSM_HOOK_INIT(ptrace_traceme,blare_ptrace_traceme),
+	LSM_HOOK_INIT(ptrace_unlink,blare_ptrace_unlink),
+	LSM_HOOK_INIT(task_free,blare_task_free),
+	LSM_HOOK_INIT(mmap_file, blare_mmap_file),
+	LSM_HOOK_INIT(file_mprotect, blare_file_mprotect),
+	LSM_HOOK_INIT(getprocattr, blare_getprocattr),
+	LSM_HOOK_INIT(setprocattr, blare_setprocattr),
+};
+
+static int __init blare_install(void)
+{
+	int ret;
+	pr_info("Blare: Information Flow Monitor.\n");
+	ret = blare_init_fs();
+	if (ret)
+		return ret;
+	blare_enabled = 0;
+	security_add_hooks(blare_hooks, ARRAY_SIZE(blare_hooks));
+	return 0;
+}
+
+module_init(blare_install);
diff --git a/security/blare/open_flows.c b/security/blare/open_flows.c
new file mode 100644
index 0000000..7ff5b81
--- /dev/null
+++ b/security/blare/open_flows.c
@@ -0,0 +1,723 @@
+/*
+ * Blare Linux Security Module
+ *
+ * Authors: Christophe Hauser <christophe@cs.ucsb.edu>
+ *          Guillaume Brogi <guillaume.brogi@akheros.com>
+ *          Laurent Georget <laurent.georget@supelec.fr>
+ *
+ * Copyright (C) 2010-2016 CentraleSupelec
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2, as
+ * published by the Free Software Foundation.
+ *
+ */
+
+#include <linux/file.h>
+#include <linux/fs.h>
+#include <linux/slab.h>
+#include <linux/gfp.h>
+#include <linux/types.h>
+#include <linux/list.h>
+#include <linux/fsnotify.h>
+#include <linux/hashtable.h>
+#include <linux/msg.h>
+#include <linux/workqueue.h>
+
+#include "blare.h"
+
+#define BLARE_HASHTABLE_SHIFT 10
+
+struct async_task_freer
+{
+	struct task_struct *task;
+	struct work_struct work;
+};
+
+struct discrete_flow {
+	struct task_struct *resp;
+	union {
+		struct file *file;
+		struct mm_struct *mm;
+		struct msg_msg *msg;
+	} src;
+	union {
+		struct file *file;
+		struct mm_struct *mm;
+	} dest;
+	int src_type;
+	int dest_type;
+	struct hlist_node by_src; /* table of enabled flows, by source */
+	struct hlist_node by_task; /* table of enabled flows, by responsible task_struct* */
+};
+
+struct bfs_elt {
+	union {
+		struct file *file;
+		struct mm_struct *mm;
+		struct msg_msg *msg;
+	} src;
+	union {
+		struct file *file;
+		struct mm_struct *mm;
+	} dest;
+	int src_type;
+	int dest_type;
+	struct list_head list; /* list of bfs_elt to visit */
+};
+
+static DEFINE_HASHTABLE(enabled_flows_by_src , BLARE_HASHTABLE_SHIFT);
+static DEFINE_HASHTABLE(enabled_flows_by_task, BLARE_HASHTABLE_SHIFT);
+static DEFINE_MUTEX(flows_lock);
+
+static int get_mms_for_file(struct file *file, struct list_head *visit_list)
+{
+	struct inode *inode = file_inode(file);
+	struct address_space *maps = inode->i_mapping;
+	struct vm_area_struct *vma;
+	struct bfs_elt *elt;
+	int ret = 0;
+
+	i_mmap_lock_read(maps);
+	vma_interval_tree_foreach(vma, &maps->i_mmap, 0, ULONG_MAX)
+	{
+		/* all vma-s are relevant here, we take a ref on the mm and we
+		 * place it on the list of stuff to visit */
+		struct mm_struct *mm = vma->vm_mm;
+
+		/* do not consider already dead mm */
+		if (!mm || !atomic_inc_not_zero(&mm->mm_users))
+			continue;
+
+		if(!mm->m_sec) {
+			mmput(mm);
+			continue;
+		}
+
+		elt = kmalloc(sizeof(struct bfs_elt), GFP_KERNEL);
+		if (!elt) {
+			ret = -ENOMEM;
+			mmput(mm);
+			goto unlock;
+		}
+
+		elt->src.file = file;
+		elt->src_type = BLARE_FILE_TYPE;
+		elt->dest.mm = mm;
+		elt->dest_type = BLARE_MM_TYPE;
+		BUG_ON(!mm->m_sec);
+		list_add_tail(&elt->list, visit_list);
+	}
+
+unlock:
+	i_mmap_unlock_read(maps);
+	return ret;
+}
+
+static int get_files_for_mm(struct mm_struct *mm, struct list_head *visit_list)
+{
+	struct vm_area_struct *vma;
+	struct file *file;
+	struct bfs_elt *elt;
+	int ret = 0;
+
+	/* only VM_SHARED with a vm_file */
+	down_read(&mm->mmap_sem);
+	for (vma = mm->mmap; vma; vma = vma->vm_next) {
+		if (!(vma->vm_flags & VM_SHARED) ||
+		    !(vma->vm_flags & VM_WRITE) ||
+		    !vma->vm_file)
+			continue;
+
+		file = vma->vm_file;
+		if (!file_inode(file) || !file_inode(file)->i_security)
+			continue;
+
+		elt = kmalloc(sizeof(struct bfs_elt), GFP_KERNEL);
+		if (!elt) {
+			ret = -ENOMEM;
+			goto unlock;
+		}
+
+		get_file(file);
+		elt->src.mm = mm;
+		elt->src_type = BLARE_FILE_TYPE;
+		elt->dest.file = file;
+		elt->dest_type = BLARE_FILE_TYPE;
+		list_add_tail(&elt->list, visit_list);
+
+	}
+unlock:
+	up_read(&mm->mmap_sem);
+	return ret;
+}
+
+static int get_discrete_flows_for_file(struct file *file, struct list_head *visit_list)
+{
+	struct discrete_flow *flow;
+	struct bfs_elt *elt;
+	struct inode *inode = file_inode(file);
+	u64 key = (u64) inode;
+	pr_debug("kblare: key for inode %llu\n",key);
+	hash_for_each_possible(enabled_flows_by_src, flow, by_src, key) {
+		struct mm_struct *mm;
+		// Check if the flow in the bucket is not for another key
+		if (flow->dest_type != BLARE_MM_TYPE ||
+		    file_inode(flow->src.file) != inode)
+			continue;
+
+		mm = flow->dest.mm;
+		BUG_ON(!mm->m_sec);
+		elt = kmalloc(sizeof(struct bfs_elt), GFP_KERNEL);
+		if (!elt)
+			return -ENOMEM;
+		atomic_inc(&mm->mm_users);
+		elt->src.file = file;
+		elt->src_type = BLARE_FILE_TYPE;
+		elt->dest.mm = mm;
+		elt->dest_type = BLARE_MM_TYPE;
+		list_add_tail(&elt->list, visit_list);
+	}
+	return 0;
+}
+
+static int get_discrete_flows_for_mm(struct mm_struct *mm, struct list_head *visit_list)
+{
+	struct discrete_flow *flow;
+	struct bfs_elt *elt;
+	u64 key = (u64) mm;
+	pr_debug("kblare: key for mm %llu\n",key);
+	hash_for_each_possible(enabled_flows_by_src, flow, by_src, key) {
+		struct file *file;
+		// Check if the flow in the bucket is not for another key
+		if (flow->dest_type != BLARE_FILE_TYPE ||
+		    flow->src.mm != mm)
+			continue;
+
+		file = flow->dest.file;
+		elt = kmalloc(sizeof(struct bfs_elt), GFP_KERNEL);
+		if (!elt)
+			return -ENOMEM;
+
+		get_file(file);
+		elt->src.mm = mm;
+		elt->src_type = BLARE_MM_TYPE;
+		elt->dest.file = file;
+		elt->dest_type = BLARE_FILE_TYPE;
+		list_add_tail(&elt->list, visit_list);
+	}
+	return 0;
+}
+
+static void propagate_tags(struct info_tags *dest, const struct info_tags *src,
+		    struct info_tags *tags_added)
+{
+  int i;
+  
+	/* short-circuit */
+	if (blare_stop_propagate(src)  || blare_stop_propagate(dest)) {
+		for (i=0 ; i<BLARE_TAGS_NUMBER ; i++)
+			tags_added->tags[i] = 0;
+		return;
+	}
+	
+	/* we have to merge the new tags with the ones already present
+	 * in the destination container */
+	for (i=0 ; i<BLARE_TAGS_NUMBER ; i++) {
+		tags_added->tags[i] = src->tags[i] & ~(dest->tags[i]);
+		if (blare_enabled)
+			dest->tags[i] |= src->tags[i];
+	}
+}
+
+static int propagate_to_mm(struct mm_struct *mm, struct list_head *visit_list, const struct info_tags *tags, struct info_tags *tags_added)
+{
+	struct blare_mm_sec *msec = mm->m_sec;
+	int ret = 0;
+
+	propagate_tags(&msec->info, tags, tags_added);
+
+	if (tags_count(tags_added) > 0) {
+		ret = get_files_for_mm(mm, visit_list);
+		if (!ret)
+			ret = get_discrete_flows_for_mm(mm, visit_list);
+	}
+
+	return ret;
+}
+
+static int propagate_to_file(struct file *file, struct list_head *visit_list, const struct info_tags *tags, struct info_tags *tags_added)
+{
+	struct inode *inode = file_inode(file);
+	struct blare_inode_sec *isec = inode->i_security;
+	int ret = 0;
+
+	propagate_tags(&isec->info, tags, tags_added);
+
+	if (tags_count(tags_added) > 0) {
+		struct dentry *dentry = dget(file_dentry(file));
+		if (blare_enabled && dentry && (inode->i_opflags & IOP_XATTR)) {
+			int rc;
+			/* Convert the shared lock into an exclusive lock
+			 * no race condition to be afraid of because the entire
+			 * tag propagation is protected by mutex flows_lock
+			 * and we have a reference on the inode */
+			inode_unlock(inode);
+			inode_lock(inode);
+			rc = __vfs_setxattr(dentry, inode,
+				BLARE_XATTR_TAG, isec->info.tags,
+				BLARE_TAGS_NUMBER * sizeof(__u32), 0);
+			if (!rc)
+				fsnotify_xattr(dentry);
+			inode_unlock(inode);
+			inode_lock_shared(inode);
+		}
+		dput(dentry);
+
+		ret = get_mms_for_file(file, visit_list);
+		if (!ret)
+			ret = get_discrete_flows_for_file(file, visit_list);
+	}
+
+	return ret;
+}
+
+static void __trace_all(const struct info_tags *tags, const struct bfs_elt *flow)
+{
+	void *src = flow->src_type == BLARE_MM_TYPE     ?    (void*) flow->src.mm :
+		    flow->src_type == BLARE_FILE_TYPE   ?    (void*) flow->src.file :
+		 /* flow->src_type == BLARE_MSG_TYPE    ? */ (void*) flow->src.msg;
+	void *dest = flow->dest_type == BLARE_MM_TYPE   ?    (void*) flow->dest.mm :
+	         /*  flow->dest_type == BLARE_FILE_TYPE ? */ (void*) flow->dest.file;
+
+	blare_trace_all(tags, src, flow->src_type, dest, flow->dest_type);
+}
+
+static int __register_new_flow(struct bfs_elt *new_flow, const struct info_tags *new_tags)
+{
+	LIST_HEAD(visit_list);
+	struct bfs_elt *next, *temp;
+	struct info_tags tags_added;
+	int ret = 0;
+
+	list_add(&new_flow->list, &visit_list);
+	list_for_each_entry(next, &visit_list, list) {
+		if (next->dest_type == BLARE_FILE_TYPE) {
+			struct file *file = next->dest.file;
+			struct inode *inode = file_inode(file);
+			inode_lock_shared(inode);
+			ret = propagate_to_file(file, &visit_list, new_tags, &tags_added);
+			inode_unlock_shared(inode);
+			fput(file);
+		} else {
+			struct mm_struct *mm = next->dest.mm;
+			ret = propagate_to_mm(mm, &visit_list, new_tags, &tags_added);
+			mmput(mm);
+		}
+
+		if (ret)
+			goto free_all_and_abort;
+
+		/* blare_trace_all can fail with ENOMEM but that's not
+		 * critical, we might just lose a few trace messages
+		 * silently */
+		if (unlikely(blare_is_traced(&tags_added)))
+			__trace_all(new_tags, next);
+	}
+
+free_all_and_abort:
+	list_for_each_entry_safe(next, temp, &visit_list, list) {
+		list_del(&next->list);
+		kfree(next);
+	}
+
+	return ret;
+
+}
+
+/* called from:
+ * - read
+ * - recv
+ * - mmap
+ */
+static int __register_flow_file_to_mm(struct file *file, struct mm_struct *mm)
+{
+	struct inode *inode = file_inode(file);
+	struct blare_inode_sec *isec = inode->i_security;
+	struct bfs_elt *first_flow;
+
+	if (!isec || !mm->m_sec || tags_count(&isec->info) == 0)
+		return 0;
+
+	first_flow = kmalloc(sizeof(struct bfs_elt), GFP_KERNEL);
+	if (!first_flow)
+		return -ENOMEM;
+
+	BUG_ON(!atomic_inc_not_zero(&mm->mm_users));
+	BUG_ON(!mm->m_sec);
+	first_flow->src.file = file;
+	first_flow->src_type = BLARE_FILE_TYPE;
+	first_flow->dest.mm = mm;
+	first_flow->dest_type = BLARE_MM_TYPE;
+	return __register_new_flow(first_flow, &isec->info);
+}
+
+int register_flow_file_to_mm(struct file *file, struct mm_struct *mm)
+{
+	int ret;
+	mutex_lock(&flows_lock);
+	ret = __register_flow_file_to_mm(file, mm);
+	mutex_unlock(&flows_lock);
+	return ret;
+}
+
+/* called from:
+ * - write
+ * - send
+ */
+static int __register_flow_mm_to_file(struct mm_struct *mm, struct file *file)
+{
+	struct inode *inode = file_inode(file);
+	struct blare_mm_sec *msec = mm->m_sec;
+	struct bfs_elt *first_flow;
+
+	if (!msec || !inode->i_security || tags_count(&msec->info) == 0)
+		return 0;
+
+	first_flow = kmalloc(sizeof(struct bfs_elt), GFP_KERNEL);
+	if (!first_flow)
+		return -ENOMEM;
+
+	get_file(file);
+	first_flow->src.mm = mm;
+	first_flow->src_type = BLARE_MM_TYPE;
+	first_flow->dest.file = file;
+	first_flow->dest_type = BLARE_FILE_TYPE;
+	return __register_new_flow(first_flow, &msec->info);
+}
+
+int register_flow_mm_to_file(struct mm_struct *mm, struct file *file)
+{
+	int ret;
+	mutex_lock(&flows_lock);
+	ret = __register_flow_mm_to_file(mm, file);
+	mutex_unlock(&flows_lock);
+	return ret;
+}
+
+/*
+ * called from:
+ * - mq_timedreceive
+ * - msgrcv
+ */
+static int __register_flow_msg_to_mm(struct msg_msg *msg, struct mm_struct *mm)
+{
+	struct blare_msg_sec *msgsec = msg->security;
+	struct bfs_elt *first_flow;
+
+	if (!msgsec || !mm->m_sec || tags_count(&msgsec->info) == 0)
+		return 0;
+
+	first_flow = kmalloc(sizeof(struct bfs_elt), GFP_KERNEL);
+	if (!first_flow)
+		return -ENOMEM;
+
+	atomic_inc(&mm->mm_users);
+	first_flow->src.msg = msg;
+	first_flow->src_type = BLARE_MSG_TYPE;
+	first_flow->dest.mm = mm;
+	first_flow->dest_type = BLARE_MM_TYPE;
+	return __register_new_flow(first_flow, &msgsec->info);
+}
+
+int register_flow_msg_to_mm(struct msg_msg *msg, struct mm_struct *mm)
+{
+	int ret;
+	mutex_lock(&flows_lock);
+	ret = __register_flow_msg_to_mm(msg, mm);
+	mutex_unlock(&flows_lock);
+	return ret;
+}
+
+/*
+ * called from setprocattr (write into /proc/self/attr/current)
+ */
+static int __register_new_tags_for_mm(const struct info_tags *new_tags, struct mm_struct *mm)
+{
+	struct bfs_elt *first_flow;
+
+	if (!new_tags || !mm->m_sec || tags_count(new_tags) == 0)
+		return 0;
+
+	first_flow = kmalloc(sizeof(struct bfs_elt), GFP_KERNEL);
+	if (!first_flow)
+		return -ENOMEM;
+
+	atomic_inc(&mm->mm_users);
+	first_flow->src.mm = current->mm;
+	first_flow->src_type = BLARE_MM_TYPE;
+	first_flow->dest.mm = mm;
+	first_flow->dest_type = BLARE_MM_TYPE;
+	return __register_new_flow(first_flow, new_tags);
+}
+
+int register_new_tags_for_mm(const struct info_tags *tags, struct mm_struct *mm)
+{
+	int ret;
+	mutex_lock(&flows_lock);
+	ret = __register_new_tags_for_mm(tags, mm);
+	mutex_unlock(&flows_lock);
+	return ret;
+}
+
+/* other flows to cover: clone (and fork...) */
+
+int register_read(struct file *file)
+{
+	int ret = 0;
+	struct mm_struct *mm = current->mm;
+	struct inode *inode =file_inode(file);
+	struct discrete_flow *flow = kmalloc(sizeof(struct discrete_flow), GFP_KERNEL);
+
+	if (!flow)
+		return -ENOMEM;
+
+	atomic_inc(&mm->mm_users);
+	flow->resp = current;
+	flow->src.file = file;
+	flow->src_type = BLARE_FILE_TYPE;
+	flow->dest.mm = mm;
+	flow->dest_type = BLARE_MM_TYPE;
+	INIT_HLIST_NODE(&flow->by_src);
+	INIT_HLIST_NODE(&flow->by_task);
+
+	mutex_lock(&flows_lock);
+	pr_debug("kblare: key for inode insertion %llu\n", (u64) inode);
+	hash_add(enabled_flows_by_src, &flow->by_src, ((u64) inode));
+	hash_add(enabled_flows_by_task, &flow->by_task, ((u64) current));
+	ret = __register_flow_file_to_mm(file, mm);
+	mutex_unlock(&flows_lock);
+
+	return ret;
+}
+
+int register_write(struct file *file)
+{
+	int ret = 0;
+	struct mm_struct *mm = current->mm;
+
+	struct discrete_flow *flow = kmalloc(sizeof(struct discrete_flow), GFP_KERNEL);
+
+	if (!flow)
+		return -ENOMEM;
+
+	get_file(file);
+	flow->resp = current;
+	flow->src.mm = mm;
+	flow->src_type = BLARE_MM_TYPE;
+	flow->dest.file = file;
+	flow->dest_type = BLARE_FILE_TYPE;
+	INIT_HLIST_NODE(&flow->by_src);
+	INIT_HLIST_NODE(&flow->by_task);
+
+	mutex_lock(&flows_lock);
+	pr_debug("kblare: key for mm insertion %llu\n", (u64) mm);
+	hash_add(enabled_flows_by_src, &flow->by_src, ((u64) mm));
+	hash_add(enabled_flows_by_task, &flow->by_task, ((u64) current));
+	ret = __register_flow_mm_to_file(mm, file);
+	mutex_unlock(&flows_lock);
+
+	return ret;
+}
+
+int register_msg_reception(struct msg_msg *msg)
+{
+	int ret = 0;
+	struct mm_struct *mm = current->mm;
+	struct discrete_flow *flow = kmalloc(sizeof(struct discrete_flow), GFP_KERNEL);
+
+	if (!flow)
+		return -ENOMEM;
+
+	atomic_inc(&mm->mm_users);
+	flow->resp = current;
+	flow->src.msg = msg;
+	flow->src_type = BLARE_FILE_TYPE;
+	flow->dest.mm = mm;
+	flow->dest_type = BLARE_MM_TYPE;
+	INIT_HLIST_NODE(&flow->by_src);
+	INIT_HLIST_NODE(&flow->by_task);
+
+	/* do not insert the msg in the discrete flows table because the
+	 * message cannot be the destination of any flow */
+	ret = register_flow_msg_to_mm(msg, mm);
+
+	return ret;
+}
+
+static void unregister_task_flow(struct task_struct *p)
+{
+	struct discrete_flow *flow;
+	mutex_lock(&flows_lock);
+	hash_for_each_possible(enabled_flows_by_task, flow, by_task, ((u64) p)) {
+		if (flow->resp == p) {
+			hash_del(&flow->by_task);
+			hash_del(&flow->by_src);
+			if (flow->dest_type == BLARE_FILE_TYPE)
+				fput(flow->dest.file);
+			else
+				mmput(flow->dest.mm);
+			kfree(flow);
+			break;
+		}
+	}
+	mutex_unlock(&flows_lock);
+}
+
+void unregister_current_flow(void)
+{
+	unregister_task_flow(current);
+}
+
+static bool task_maybe_hashed__unlocked(struct task_struct *task)
+{
+	int i = hash_min((u64) task, HASH_BITS(enabled_flows_by_task));
+	return !hlist_empty(&enabled_flows_by_task[i]);
+}
+
+static void async_unregister_task_flow(struct work_struct* freer)
+{
+	struct async_task_freer *f = container_of(freer, struct async_task_freer, work);
+	unregister_task_flow(f->task);
+	kfree(f);
+}
+
+ /*
+  * This can be called from interrupt context from blare_task_free so populate
+  * a workqueue to do the work
+  */
+void unregister_dying_task_flow(struct task_struct *task)
+{
+	struct async_task_freer *f;
+
+	/* Kernel threads are not of our concern */
+	if (!current->mm)
+		return;
+
+	/* we can take a quick look at the hash table without taking the lock
+	 * because we cannot race with the insertion of a node by ourselves
+	 * (remember we are exiting) */
+	if (likely(!task_maybe_hashed__unlocked(task)))
+		return;
+
+	f = kmalloc(sizeof(*f), GFP_ATOMIC);
+	/* In case of such a very low memory situation, there is not a lot we
+	 * can do */
+	if (!f)
+		return;
+	f->task = task;
+	INIT_WORK(&f->work, async_unregister_task_flow);
+	schedule_work(&f->work);
+}
+
+int register_ptrace_attach(struct task_struct *tracer, struct task_struct *child)
+{
+	struct mm_struct *child_mm = child->mm;
+	struct blare_mm_sec *child_msec = child_mm->m_sec;
+struct blare_mm_sec *tracer_msec = tracer->mm->m_sec;
+/* we do the m_sec shring under mutex in order not to propagate tags
+	 * inconsistently if the old m_sec is being used */
+	mutex_lock(&flows_lock);
+	msec_get(tracer_msec);
+	child_mm->m_sec = tracer_msec;
+	msec_put(child_msec);
+	mutex_unlock(&flows_lock);
+
+	return 0;
+}
+
+void unregister_ptrace(struct task_struct *child)
+{
+	struct mm_struct *child_mm = child->mm;
+	struct blare_mm_sec *tracer_msec = current->mm->m_sec;
+	/* we do the m_sec shring under mutex in order not to propagate tags
+	 * inconsistently if the old m_sec is being used */
+	mutex_lock(&flows_lock);
+	child_mm->m_sec = dup_msec(tracer_msec);
+	/* Ups, no more memory but no way to return an error :/
+	 * we will proceed as if the caller had ask for the tracee to be killed
+	 * on detaching */
+	if (IS_ERR(child_mm->m_sec)) {
+		send_sig_info(SIGKILL, SEND_SIG_FORCED, child);
+		child_mm->m_sec = NULL;
+	}
+	msec_put(tracer_msec);
+	mutex_unlock(&flows_lock);
+}
+
+struct blare_mm_sec *dup_msec(struct blare_mm_sec *old_msec)
+{
+	struct blare_mm_sec *msec;
+	msec = kmalloc(sizeof(struct blare_mm_sec), GFP_KERNEL);
+	if (!msec)
+		goto nomem;
+	copy_tags(&msec->info, &old_msec->info);
+	atomic_set(&msec->users, 1);
+	return msec;
+
+nomem:
+	return ERR_PTR(-ENOMEM);
+}
+
+void msec_get(struct blare_mm_sec *msec)
+{
+	atomic_inc_not_zero(&msec->users);
+}
+
+void msec_put(struct blare_mm_sec *msec)
+{
+	if (atomic_dec_and_test(&msec->users)) {
+		kfree(msec);
+	}
+}
+
+#if 0
+static noinline int generic_add_tags(struct info_tags *dest, struct dentry *dest_dentry, const struct info_tags *src)
+{
+	int rc;
+	struct info_tags tags = {0, NULL};
+
+	rc = add_tags(dest, src, &tags);
+	if (rc < 0 || tags.count == 0)
+		 return rc;
+
+	rc = 0;
+	if (dest_dentry) {
+		struct inode *inode = d_backing_inode(dest_dentry);
+		if (!inode) {
+			pr_err("Blare: No inode corresponding to dentry");
+			rc = -ENODATA;
+		} else if (inode->i_op->setxattr) {
+			inode_lock(inode);
+			rc = inode->i_op->setxattr(dest_dentry, inode,
+						   BLARE_XATTR_TAG,
+						   tags.tags, tags.count,
+						   0);
+			if (!rc)
+				fsnotify_xattr(dest_dentry);
+			inode_unlock(inode);
+		}
+	}
+
+	if (rc >= 0) { /* the new tags have been computed and propagated into the
+		      inode's xattr, if required. Time to commit the changes */
+		__s32 *old_tags = dest->tags;
+		dest->tags = tags.tags;
+		dest->count = tags.count;
+		kfree(old_tags);
+	}
+
+	 return rc;
+}
+}
+#endif
diff --git a/security/blare/securityfs.c b/security/blare/securityfs.c
new file mode 100644
index 0000000..c230573
--- /dev/null
+++ b/security/blare/securityfs.c
@@ -0,0 +1,467 @@
+#include <linux/security.h>
+#include <linux/seq_file.h>
+#include <linux/stringify.h>
+#include <linux/msg.h>
+
+#include "blare.h"
+
+#define BLARE_TAGS_NUMBER_STR __stringify(BLARE_TAGS_NUMBER)
+
+static __u32 blare_traced[BLARE_TAGS_NUMBER];
+int blare_enabled;
+
+static char* __blare_print_file(struct file* file)
+{
+	int n = snprintf(NULL, 0, "%pd4", file->f_path.dentry);
+	char *str = kmalloc(n + 1, GFP_KERNEL);
+	if (!str)
+		return ERR_PTR(-ENOMEM);
+	snprintf(str, n + 1, "%pd4", file->f_path.dentry);
+	return str;
+}
+
+static char* __blare_print_task(struct task_struct* p)
+{
+	int n = snprintf(NULL, 0, "process %i | %s", p->pid, p->comm);
+	char *str = kmalloc(n + 1, GFP_KERNEL);
+	if (!str)
+		return ERR_PTR(-ENOMEM);
+	snprintf(str, n + 1, "process %i | %s", p->pid, p->comm);
+	return str;
+}
+
+static char* __blare_print_msg(struct msg_msg* msg)
+{
+	int n = snprintf(NULL, 0, "msg %p", msg);
+	char *str = kmalloc(n + 1, GFP_KERNEL);
+	if (!str)
+		return ERR_PTR(-ENOMEM);
+	snprintf(str, n + 1, "msg %p", msg);
+	return str;
+}
+
+static int __blare_trace_mm(int tag, struct mm_struct *mm, char *src_str)
+{
+	char *dest_str;
+	struct task_struct *p;
+	for_each_process(p) {
+		if (!p->mm || p->mm != mm)
+			continue;
+		dest_str = __blare_print_task(p);
+		if (IS_ERR(dest_str))
+			return PTR_ERR(dest_str);
+		pr_info("blare_trace: [itag %i]: %s -> %s (current: _%s(pid %d;cpu %d;parent %d)_)",
+				tag, src_str, dest_str, current->comm, current->pid, current->on_cpu, current->real_parent->pid);
+		kfree(dest_str);
+	}
+	return 0;
+}
+
+static int blare_trace(int tag, void *src, int source_type, void *dest, int dest_type)
+{
+	char *src_str;
+	struct task_struct *p;
+	int rc = 0;
+
+	if (source_type == BLARE_MM_TYPE) {
+		struct mm_struct *mm = (struct mm_struct*) src;
+		for_each_process(p) {
+			if (!p->mm || p->mm != mm)
+				continue;
+			src_str = __blare_print_task(p);
+			if (IS_ERR(src_str)) {
+				rc = PTR_ERR(src_str);
+				break;
+			}
+			if (dest_type == BLARE_MM_TYPE) {
+				struct mm_struct *dest_mm = (struct mm_struct*)dest;
+				rc = __blare_trace_mm(tag, dest_mm, src_str);
+				if (rc) {
+					kfree(src_str);
+					break;
+				}
+			} else {
+				char *dest_str = __blare_print_file((struct file*) dest);
+
+				if (IS_ERR(dest_str)) {
+					kfree(src_str);
+					rc = PTR_ERR(dest_str);
+					break;
+				}
+				pr_info("blare_trace: [itag %i]: %s -> %s (current: _%s(pid %d;cpu %d;parent %d)_)",
+					tag, src_str, dest_str, current->comm, current->pid, current->on_cpu, current->real_parent->pid);
+			}
+		}
+	} else {
+		if (source_type == BLARE_FILE_TYPE)
+			src_str = __blare_print_file((struct file*) src);
+		else
+			src_str = __blare_print_msg((struct msg_msg*) src);
+
+		if (IS_ERR(src_str)) {
+			rc = PTR_ERR(src_str);
+			goto end;
+		}
+
+		if (dest_type == BLARE_MM_TYPE) {
+			struct mm_struct *dest_mm = (struct mm_struct*)dest;
+			rc = __blare_trace_mm(tag, dest_mm, src_str);
+			if (rc)
+				goto end;
+		} else {
+			char *dest_str = __blare_print_file((struct file*) dest);
+
+			if (IS_ERR(dest_str)) {
+				rc = PTR_ERR(dest_str);
+				goto end;
+			}
+			pr_info("blare_trace: [itag %i]: %s -> %s (current: _%s(pid %d;cpu %d;parent %d)_)",
+					tag, src_str, dest_str, current->comm, current->pid, current->on_cpu, current->real_parent->pid);
+		}
+
+end:
+		kfree(src_str);
+	}
+
+	return rc;
+}
+
+static bool __is_traced(int tag)
+{
+	int index;
+	int offset;
+
+	if (tag < 0 || tag >= BLARE_TAGS_NUMBER * 32)
+		return false;
+
+	index = tag / 32;
+	offset = tag % 32;
+	return blare_traced[index] & (1 << offset);
+}
+
+bool blare_is_traced(const struct info_tags* tags_added)
+{
+	int i;
+	for (i=0 ; i<BLARE_TAGS_NUMBER ; i++)
+		if (tags_added->tags[i] & blare_traced[i])
+			return true;
+	return false;
+}
+
+int blare_trace_all(const struct info_tags* tags_added, void* src, int src_type,
+		void* dest, int dest_type)
+
+{
+	int tag;
+	int rc;
+	for (tag=0 ; tag<BLARE_TAGS_NUMBER * 32 ; tag++) {
+		if (unlikely(__is_traced(tag))) {
+			rc = blare_trace(tag, src, src_type, dest, dest_type);
+			if (rc)
+				return rc;
+		}
+	}
+
+	return 0;
+}
+
+int blare_tags_to_string(const __u32 *tag, char** buffer)
+{
+	int i,j;
+	int length = 0;
+	char *buf;
+	int offset;
+	/* compute the size needed for the buffer allocation */
+	for (i=0 ; i<BLARE_TAGS_NUMBER ; i++)
+		for (j=0 ; j<32 ; j++)
+			if (tag[i] & (1 << j))
+				length += snprintf(NULL, 0, "%d ", i*32 + j);
+
+	buf = kmalloc(length + 1, GFP_KERNEL); /* +1 for the final \0 */
+	if (!buf)
+		return -ENOMEM;
+
+	offset = 0;
+	/* populate the buffer */
+	for (i=0 ; i<BLARE_TAGS_NUMBER ; i++)
+		for (j=0 ; j<32 ; j++)
+			if (tag[i] & (1 << j))
+				offset += snprintf(buf + offset, length - offset, "%d ", i*32 + j);
+
+	/* Replace the last space by a line return and finish the string */
+	buf[length-1] = '\n';
+	buf[length] = '\0';
+
+	*buffer = buf;
+
+	return length;
+}
+
+int blare_tags_from_string(const char* buf, size_t length, __u32 *tags)
+{
+	int offset = 0;
+	__u32 tag;
+	int nbytes;
+
+	memset(tags, 0, BLARE_TAGS_NUMBER * sizeof(__u32));
+	while (offset < length &&
+	       sscanf(buf + offset, "%d%n", &tag, &nbytes)) {
+		offset += nbytes;
+		if (tag < 0 || tag >= BLARE_TAGS_NUMBER * 32) {
+			pr_err("blare: Invalid tag (off-range): %i", tag);
+			continue;
+		}
+
+		tags[tag / 32] |= 1 << (tag % 32);
+	}
+
+	if (!offset)
+		return -EINVAL;
+	if (buf[offset] == '\n')
+		offset++;
+	return offset;
+}
+
+static int blare_fs_itag_size_show(struct seq_file *seq, void *v)
+{
+	seq_puts(seq, BLARE_TAGS_NUMBER_STR"\n");
+	return 0;
+}
+
+static int blare_fs_itag_size_open(struct inode *inode, struct file *file)
+{
+	return single_open(file, blare_fs_itag_size_show, NULL);
+}
+
+static int blare_fs_traced_show(struct seq_file *seq, void *v)
+{
+	int i, j;
+	for (i=0 ; i<BLARE_TAGS_NUMBER ; i++) {
+		for (j=0 ; j<32 ; j++) {
+			if (unlikely(blare_traced[i] & (1 << j)))
+				seq_printf(seq, "%d ", i * 32 + j);
+		}
+	}
+	seq_puts(seq, "\n");
+	return 0;
+}
+
+static int blare_fs_traced_open(struct inode *inode, struct file *file)
+{
+	return single_open(file, blare_fs_traced_show, NULL);
+}
+
+static void __blare_fs_mark_as_traced(int tag)
+{
+	int index = tag / 32;
+	int offset = tag % 32;
+	blare_traced[index] |= 1 << offset;
+}
+
+static void __blare_fs_mark_as_untraced(int tag)
+{
+	int index = tag / 32;
+	int offset = tag % 32;
+	blare_traced[index] &= ~(1 << offset);
+}
+
+static ssize_t __blare_fs_trace_untrace_write(struct file *file, const char __user *buf,
+		size_t count, loff_t *ppos, void(*marker)(int))
+{
+	char *new_tags;
+	int nbytes, offset;
+	__u32 tag;
+
+	/* wow wow wow, calm down right now! */
+	if (count >= PAGE_SIZE)
+		return -ENOMEM;
+
+	/* No partial writes. */
+	if (*ppos != 0)
+		return -EINVAL;
+
+	new_tags = memdup_user_nul(buf, count);
+	if (IS_ERR(new_tags))
+		return PTR_ERR(new_tags);
+
+	offset = 0;
+	while (sscanf(new_tags + offset, "%d%n", &tag, &nbytes)) {
+		offset += nbytes;
+		if (tag < 0 || tag >= BLARE_TAGS_NUMBER * 32) {
+			pr_err("blare: Invalid tag (off-range): %i", tag);
+			continue;
+		}
+
+		marker(tag);
+	}
+
+	kfree(new_tags);
+
+	if (!offset)
+		return -EINVAL;
+
+	/* \n at end of input is ok, just pretend having written it */
+	if (new_tags[offset] == '\n')
+		offset++;
+
+	return offset;
+}
+
+static ssize_t blare_fs_trace_write(struct file *file, const char __user *buf,
+		size_t count, loff_t *ppos)
+{
+	return __blare_fs_trace_untrace_write(file, buf, count, ppos, __blare_fs_mark_as_traced);
+}
+
+static ssize_t blare_fs_untrace_write(struct file *file, const char __user *buf,
+		size_t count, loff_t *ppos)
+{
+	return __blare_fs_trace_untrace_write(file, buf, count, ppos, __blare_fs_mark_as_untraced);
+}
+
+static int blare_fs_enabled_show(struct seq_file *seq, void *v)
+{
+	seq_printf(seq, "%d\n", blare_enabled);
+	return 0;
+}
+
+static int blare_fs_enabled_open(struct inode *inode, struct file *file)
+{
+	return single_open(file, blare_fs_enabled_show, NULL);
+}
+
+static ssize_t blare_fs_enabled_write(struct file *file, const char __user *buf,
+		size_t count, loff_t *ppos)
+{
+	char *data;
+	int rc;
+	if (!capable(CAP_MAC_ADMIN))
+		return -EPERM;
+
+	if (*ppos != 0)
+		return -EINVAL;
+
+	if (count > 2)
+		return -EINVAL;
+
+	data = memdup_user(buf, count);
+	if (IS_ERR(data))
+		return PTR_ERR(data);
+
+	if (count == 2 && data[1] != '\n') {
+		rc = -EINVAL;
+		goto out;
+	}
+
+	if (data[0] == '0') {
+		blare_enabled = 0;
+		pr_info("*** BLARE IS DISABLED ***");
+		rc = count;
+	} else if (data[0] == '1') {
+		blare_enabled = 1;
+		pr_info("*** BLARE IS ENABLED ***");
+		rc = count;
+	} else {
+		rc = -EINVAL;
+	}
+
+out:
+	kfree(data);
+	return rc;
+}
+
+static const struct file_operations blare_itag_size_ops = {
+	.owner		= THIS_MODULE,
+	.open		= blare_fs_itag_size_open,
+	.read		= seq_read,
+	.release	= single_release,
+};
+
+static const struct file_operations blare_traced_ops = {
+	.owner		= THIS_MODULE,
+	.open		= blare_fs_traced_open,
+	.read		= seq_read,
+	.llseek		= seq_lseek,
+	.release	= single_release,
+};
+
+static const struct file_operations blare_trace_ops = {
+	.owner		= THIS_MODULE,
+	.write		= blare_fs_trace_write,
+};
+
+static const struct file_operations blare_untrace_ops = {
+	.owner		= THIS_MODULE,
+	.write		= blare_fs_untrace_write,
+};
+
+static const struct file_operations blare_enabled_ops = {
+	.owner		= THIS_MODULE,
+	.open		= blare_fs_enabled_open,
+	.read		= seq_read,
+	.write		= blare_fs_enabled_write,
+	.release	= single_release,
+};
+
+int blare_init_fs()
+{
+	struct dentry *root;
+	struct dentry *itag_size, *traced, *trace, *untrace, *enabled;
+	int ret;
+
+	root = securityfs_create_dir("blare", NULL);
+	if (IS_ERR(root)) {
+		ret = PTR_ERR(root);
+		goto error_root;
+	}
+
+	itag_size = securityfs_create_file("itag_size", 0444, root, NULL,
+				      &blare_itag_size_ops);
+	if (IS_ERR(itag_size)) {
+		ret = PTR_ERR(itag_size);
+		goto error_itag_size;
+	}
+
+	traced = securityfs_create_file("traced", 0444, root, NULL,
+				      &blare_traced_ops);
+	if (IS_ERR(traced)) {
+		ret = PTR_ERR(traced);
+		goto error_traced;
+	}
+
+	trace = securityfs_create_file("trace", 0600, root, NULL,
+				      &blare_trace_ops);
+	if (IS_ERR(trace)) {
+		ret = PTR_ERR(trace);
+		goto error_trace;
+	}
+
+	untrace = securityfs_create_file("untrace", 0600, root, NULL,
+				      &blare_untrace_ops);
+	if (IS_ERR(untrace)) {
+		ret = PTR_ERR(untrace);
+		goto error_untrace;
+	}
+
+	enabled = securityfs_create_file("enabled", 0644, root, NULL,
+				      &blare_enabled_ops);
+	if (IS_ERR(enabled)) {
+		ret = PTR_ERR(enabled);
+		goto error_enabled;
+	}
+	return 0;
+
+error_enabled:
+	securityfs_remove(untrace);
+error_untrace:
+	securityfs_remove(trace);
+error_trace:
+	securityfs_remove(traced);
+error_traced:
+	securityfs_remove(itag_size);
+error_itag_size:
+	securityfs_remove(root);
+error_root:
+	pr_err("Blare: Couldn't initialize Blare securityfs dir");
+	return ret;
+}
diff --git a/security/security.c b/security/security.c
index f825304..ec9f56f 100644
--- a/security/security.c
+++ b/security/security.c
@@ -26,6 +26,7 @@
 #include <linux/personality.h>
 #include <linux/backing-dev.h>
 #include <net/flow.h>
+#include <linux/mm_types.h>
 
 #define MAX_LSM_EVM_XATTR	2
 
@@ -1589,6 +1590,31 @@ int security_audit_rule_match(u32 secid, u32 field, u32 op, void *lsmrule,
 }
 #endif /* CONFIG_AUDIT */
 
+void security_syscall_before_return()
+{
+	call_void_hook(syscall_before_return);
+}
+
+int security_mm_dup_security(struct mm_struct *mm, struct mm_struct *oldmm)
+{
+	return call_int_hook(mm_dup_security, 0, mm, oldmm);
+}
+
+void security_mm_sec_free(struct mm_struct *mm)
+{
+	call_void_hook(mm_sec_free, mm);
+}
+
+int security_mq_store_msg(struct msg_msg *msg)
+{
+	return call_int_hook(mq_store_msg, 0, msg);
+}
+
+void security_ptrace_unlink(struct task_struct *p)
+{
+	call_void_hook(ptrace_unlink, p);
+}
+
 struct security_hook_heads security_hook_heads = {
 	.binder_set_context_mgr =
 		LIST_HEAD_INIT(security_hook_heads.binder_set_context_mgr),
@@ -1940,4 +1966,14 @@ struct security_hook_heads security_hook_heads = {
 	.audit_rule_free =
 		LIST_HEAD_INIT(security_hook_heads.audit_rule_free),
 #endif /* CONFIG_AUDIT */
+	.syscall_before_return =
+		LIST_HEAD_INIT(security_hook_heads.syscall_before_return),
+	.mm_dup_security =
+		LIST_HEAD_INIT(security_hook_heads.mm_dup_security),
+	.mm_sec_free =
+		LIST_HEAD_INIT(security_hook_heads.mm_sec_free),
+	.mq_store_msg =
+		LIST_HEAD_INIT(security_hook_heads.mq_store_msg),
+	.ptrace_unlink =
+		LIST_HEAD_INIT(security_hook_heads.ptrace_unlink),
 };
